VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "CeeFax Explorer"
   ClientHeight    =   7608
   ClientLeft      =   120
   ClientTop       =   1032
   ClientWidth     =   9744
   Icon            =   "frmMain.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7608
   ScaleWidth      =   9744
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer2 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   8280
      Top             =   3840
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   7728
      Top             =   5280
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      Height          =   6048
      Left            =   120
      ScaleHeight     =   6000
      ScaleWidth      =   5760
      TabIndex        =   0
      Top             =   120
      Width           =   5808
   End
   Begin MSComDlg.CommonDialog dlgCommonDialog 
      Left            =   7680
      Top             =   5808
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileSave 
         Caption         =   "Save File..."
      End
      Begin VB.Menu mnuFilePrint 
         Caption         =   "Print File"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About CeeFax Explorer..."
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Dim EM7Font(3, 96, 20) As Integer
Dim FrameB() As Byte
Dim txtFile() As Byte
Dim gName As String
    
Dim numFrames As Long
Dim curFrame As Long
Dim curChan As Integer

Dim framebuff(4, 24, 40) As Byte
Dim grabflag(4) As Boolean
Dim fullflag(4) As Boolean
Dim searching As Boolean

Dim np(3) As Integer
Dim npc As Integer
Dim pn(4) As Integer
Dim pl(4, 3) As Integer

Dim Mode7FlashOn As Integer
Dim Mode7DoubleHeightFlags(80) As Integer ' Pessimistic size for this flags - if 1 then corresponding character on NEXT line is top half
Dim CurrentLineBottom As Integer
Dim NextLineBottom As Integer

Private Declare Function OSWinHelp% Lib "user32" Alias "WinHelpA" (ByVal hWnd&, ByVal HelpFile$, ByVal wCommand%, dwData As Any)
  
Private Sub DoLink(li As Integer)

Dim z As Integer
Dim y As Integer

    If pn(li) <> 0 Then
        
        pn(0) = pn(li)
    
        np(1) = 48 + (pn(0) \ 100)
        np(2) = 48 + ((pn(0) \ 10) Mod 10)
        np(3) = 48 + (pn(0) Mod 10)
        
        If fullflag(li) = True Then
        
            For z = 1 To 24
                For y = 0 To 39
                    framebuff(0, z, y) = framebuff(li, z, y)
                Next y
            Next z
        
            fullflag(0) = True
            searching = False
                
        Else
            
            fullflag(0) = False
            searching = True
                
        End If
        
        pn(1) = pl(li, 0)
        pn(2) = pl(li, 1)
        pn(3) = pl(li, 2)
        pn(4) = pl(li, 3)
        
        ClearLinkBuff
    
    End If

End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

Dim X As Integer
Dim y As Integer
Dim z As Integer

    If KeyCode >= Asc("0") And KeyCode <= Asc("9") Then
        If npc = 0 Then
            np(1) = 32
            np(2) = 32
            np(3) = 32
        End If
        npc = npc + 1
        np(npc) = KeyCode
        If npc = 3 Then
            npc = 0
            pn(0) = (np(1) - 48) * 100 + (np(2) - 48) * 10 + (np(3) - 48)
            searching = True
        End If
    End If
    
    If KeyCode >= 112 And KeyCode <= 115 Then
    
        DoLink KeyCode - 111
    
    End If
    
    If KeyCode >= 116 And KeyCode <= 119 Then
    
        curChan = KeyCode - 116
       
        LoadChannel curChan
    
'        Parse
        
    End If
    
End Sub

Public Sub Form_Load()
    
Dim X As Integer
Dim y As Integer

    Me.Left = GetSetting(App.Title, "Settings", "TeletextLeft", 84)
    Me.Top = GetSetting(App.Title, "Settings", "TeletextTop", 84)
    
    BuildMode7Font

    Me.Width = (480 + 30) * Screen.TwipsPerPixelX
    Me.Height = (500 + 110) * Screen.TwipsPerPixelY
    
    Picture1.Width = (480 + 4) * Screen.TwipsPerPixelX
    Picture1.Height = (500 + 4) * Screen.TwipsPerPixelY
    
    Picture1.Top = 10 * Screen.TwipsPerPixelY
    Picture1.Left = 10 * Screen.TwipsPerPixelX
    
    Picture1.ScaleMode = 3
    
    Me.Show
    
    Mode7FlashOn = 0
    
    curChan = 0
       
    LoadChannel curChan
   
'    Parse
    
    ShowMode7 24
    
    Timer1.Enabled = True
    
End Sub

Private Sub mnuFileExit_Click()

    Unload Me
    
End Sub

Public Sub mnuHelpAbout_Click()
    frmAbout.Show vbModal, Me
End Sub

Private Sub Form_Unload(Cancel As Integer)

    If Me.WindowState <> vbMinimized Then
        SaveSetting App.Title, "Settings", "TeletextLeft", Me.Left
        SaveSetting App.Title, "Settings", "TeletextTop", Me.Top
    End If

End Sub

Private Sub mnuFilePrint_Click()
  
    Printer.PaintPicture Picture1.Image, 0, 0
    Printer.EndDoc
    
End Sub

Private Sub mnuFileSave_Click()

Dim hSend
Dim sNewName As String

    On Error Resume Next
    
    dlgCommonDialog.FileName = "Page_" + Mid(Str(pn(0)), 2) & ".bmp"
    dlgCommonDialog.DialogTitle = "Save File As"
    dlgCommonDialog.Filter = "Save File (*.BMP)|*.bmp|All Files (*.*)|*.*"
    dlgCommonDialog.CancelError = True
    dlgCommonDialog.ShowSave
    If Err = cdlCancel Then
        Exit Sub
    End If
    
    If dlgCommonDialog.FileName = "" Then
        Exit Sub
    End If
    
    sNewName = dlgCommonDialog.FileName

    SavePicture Picture1.Image, sNewName

End Sub

Private Sub BuildMode7Font()

Dim m7File As Integer
Dim m7cc As Byte
Dim m7cy As Byte
Dim m7cb As Integer
Dim row1 As Integer ' row builders for mode 7 graphics
Dim row2 As Integer
Dim row3 As Integer
Dim TxtFnt As String
Dim flen As Long
Dim i As Integer

 ' Build enhanced mode 7 font
    
    TxtFnt = App.Path & "\teletext.fnt"
    
    If Dir(TxtFnt) = "" Then
        Dim errstr As String
        errstr = "Cannot open Teletext font file teletext.fnt"
        MsgBox errstr, vbOK Or vbCritical, "WindowTitle"
        End
    End If
    
    flen = FileLen(TxtFnt)
    
    m7File = FreeFile
    
    Open TxtFnt For Binary As #m7File
    
' Copy in file

    ReDim txtFile(flen - 1)
    
    Get #m7File, 1, txtFile
    
    Close #m7File
    
    i = 0
    
    For m7cc = 32 To 127
        For m7cy = 0 To 17
            m7cb = txtFile(i)
            i = i + 1
            m7cb = m7cb Or txtFile(i) * 256
            i = i + 1
            EM7Font(0, m7cc - 32, m7cy + 2) = m7cb * 4
            EM7Font(1, m7cc - 32, m7cy + 2) = m7cb * 4
            EM7Font(2, m7cc - 32, m7cy + 2) = m7cb * 4
        Next m7cy
        EM7Font(2, m7cc - 32, 0) = 0
        EM7Font(1, m7cc - 32, 0) = EM7Font(2, m7cc - 32, 0)
        EM7Font(0, m7cc - 32, 0) = EM7Font(1, m7cc - 32, 0)
        EM7Font(2, m7cc - 32, 1) = 0
        EM7Font(1, m7cc - 32, 1) = EM7Font(2, m7cc - 32, 1)
        EM7Font(0, m7cc - 32, 1) = EM7Font(1, m7cc - 32, 1)
    Next m7cc
    
    ' Now fill in the graphics - this is built from an algorithm, but has certain lines/columns
    ' blanked for separated graphics.
    For m7cc = 0 To 95
        ' here's how it works: top two blocks: 1 & 2
        ' middle two blocks: 4 & 8
        ' bottom two blocks: 16 & 64
        ' its only a grpahics character if bit 5 (32) is clear.
        If (m7cc And 32) = 0 Then
            row1 = 0
            row2 = 0
            row3 = 0
            ' left block has a value of 4032, right 63 and both 4095
            If (m7cc And 1) <> 0 Then
                row1 = row1 Or 4032
            End If
            If (m7cc And 2) <> 0 Then
                row1 = row1 Or 63
            End If
            If (m7cc And 4) <> 0 Then
                row2 = row2 Or 4032
            End If
            If (m7cc And 8) <> 0 Then
                row2 = row2 Or 63
            End If
            If (m7cc And 16) <> 0 Then
                row3 = row3 Or 4032
            End If
            If (m7cc And 64) <> 0 Then
                row3 = row3 Or 63
            End If
            ' now input these values into the array
            ' top row of blocks - continuous
            EM7Font(1, m7cc, 2) = row1
            EM7Font(1, m7cc, 1) = EM7Font(1, m7cc, 2)
            EM7Font(1, m7cc, 0) = EM7Font(1, m7cc, 1)
            EM7Font(1, m7cc, 5) = row1
            EM7Font(1, m7cc, 4) = EM7Font(1, m7cc, 5)
            EM7Font(1, m7cc, 3) = EM7Font(1, m7cc, 4)
            ' Separated
            row1 = row1 And 975 ' insert gaps
            EM7Font(2, m7cc, 2) = row1
            EM7Font(2, m7cc, 1) = EM7Font(2, m7cc, 2)
            EM7Font(2, m7cc, 0) = EM7Font(2, m7cc, 1)
            EM7Font(2, m7cc, 3) = row1
            EM7Font(2, m7cc, 5) = 0
            EM7Font(2, m7cc, 4) = EM7Font(2, m7cc, 5)
            ' middle row of blocks - continuous
            EM7Font(1, m7cc, 8) = row2
            EM7Font(1, m7cc, 7) = EM7Font(1, m7cc, 8)
            EM7Font(1, m7cc, 6) = EM7Font(1, m7cc, 7)
            EM7Font(1, m7cc, 11) = row2
            EM7Font(1, m7cc, 10) = EM7Font(1, m7cc, 11)
            EM7Font(1, m7cc, 9) = EM7Font(1, m7cc, 10)
            EM7Font(1, m7cc, 13) = row2
            EM7Font(1, m7cc, 12) = EM7Font(1, m7cc, 13)
            ' Separated
            row2 = row2 And 975 ' insert gaps
            EM7Font(2, m7cc, 8) = row2
            EM7Font(2, m7cc, 7) = EM7Font(2, m7cc, 8)
            EM7Font(2, m7cc, 6) = EM7Font(2, m7cc, 7)
            EM7Font(2, m7cc, 11) = row2
            EM7Font(2, m7cc, 10) = EM7Font(2, m7cc, 11)
            EM7Font(2, m7cc, 9) = EM7Font(2, m7cc, 10)
            EM7Font(2, m7cc, 13) = 0
            EM7Font(2, m7cc, 12) = EM7Font(2, m7cc, 13)
            ' Bottom row - continuous
            EM7Font(1, m7cc, 16) = row3
            EM7Font(1, m7cc, 15) = EM7Font(1, m7cc, 16)
            EM7Font(1, m7cc, 14) = EM7Font(1, m7cc, 15)
            EM7Font(1, m7cc, 19) = row3
            EM7Font(1, m7cc, 18) = EM7Font(1, m7cc, 19)
            EM7Font(1, m7cc, 17) = EM7Font(1, m7cc, 18)
            ' Separated
            row3 = row3 And 975 ' insert gaps
            EM7Font(2, m7cc, 16) = row3
            EM7Font(2, m7cc, 15) = EM7Font(2, m7cc, 16)
            EM7Font(2, m7cc, 14) = EM7Font(2, m7cc, 15)
            EM7Font(2, m7cc, 17) = row3
            EM7Font(2, m7cc, 19) = 0
            EM7Font(2, m7cc, 18) = EM7Font(2, m7cc, 19)
        
        End If ' check for valid char to modify
    
    Next m7cc ' character loop.
    
End Sub ' BuildMode7Font

Private Sub ShowMode7(lines As Integer)

Dim CurrentPtr As String
Dim CurrentChar As Integer
Dim XStep As Integer
Dim sbyte As Byte
Dim tmp As Integer

Dim Foreground As Long
Dim NewForeground As Long
Dim ActualForeground As Long
Dim Background As Long
Dim Flash As Integer
Dim DoubleHeight As Integer
Dim Graphics As Integer
Dim Separated As Integer
Dim HoldGraph As Integer
' That's ok. Nobody else does either, and nor do I. - Richard Gellman.
Dim HoldGraphChar
Dim CurrentCol(20) As Long
Dim CurrentLen(20) As Integer
Dim CurrentStartX(20) As Integer
Dim CurrentScanLine As Integer
Dim CurrentX As Integer
Dim CurrentPixel As Integer
Dim col As Long
Dim FontTypeIndex As Integer

Dim cols(7) As Long

Dim i As Integer
Dim starty As Integer

    Me.Caption = "View Teletext Page - " & pn(0)

    i = 0
    
    cols(0) = RGB(0, 0, 0)
    cols(1) = RGB(255, 0, 0)
    cols(2) = RGB(0, 255, 0)
    cols(3) = RGB(255, 255, 0)
    cols(4) = RGB(0, 0, 255)
    cols(5) = RGB(255, 0, 255)
    cols(6) = RGB(0, 255, 255)
    cols(7) = RGB(255, 255, 255)
    
    Me.Height = (20 * 25 + 110) * Screen.TwipsPerPixelY
    
    Picture1.Height = (20 * 25 + 4) * Screen.TwipsPerPixelY
    
    For starty = 0 To lines
    
    Foreground = cols(7)
    NewForeground = cols(7)
    Background = cols(0)
    Flash = 0 ' i.e. steady
    DoubleHeight = 0 ' Normal
    Graphics = 0 ' I.e. alpha
    Separated = 0 ' i.e. continuous graphics
    HoldGraph = 0 ' I.e. don't hold graphics - I don't know what hold graphics is anyway!
    ' That's ok. Nobody else does either, and nor do I. - Richard Gellman.
    HoldGraphChar = 32 ' AHA! we know what it is now, this is the character to "hold" during control codes
  
    For i = 0 To 19
        CurrentLen(i) = 0
        CurrentStartX(i) = 0
        CurrentCol(i) = &HFFFFFF
    Next i
    
    CurrentX = 0
    FontTypeIndex = 0 ' 0=alpha, 1=contiguous graphics, 2=separated graphics
  
    XStep = 1

    For CurrentChar = 0 To 39
        
        Foreground = NewForeground
        
        sbyte = framebuff(0, starty, CurrentChar)
        
        If sbyte < 32 Then ' fix for naughty programs that use 7-bit control codes - Richard Gellman
            sbyte = sbyte + 128
        End If
        
        If ((sbyte And 32) <> 0) And (Graphics = 1) Then
            HoldGraphChar = sbyte
        End If
        
        If (sbyte >= 128) And (sbyte <= 159) Then
            Select Case sbyte
            Case 129, 130, 131, 132, 133, 134, 135
                NewForeground = cols(sbyte - 128)
                Graphics = 0

            Case 136
                Flash = 1

            Case 137
                Flash = 0

            Case 140
                DoubleHeight = 0

            Case 141
                If CurrentLineBottom = 0 Then
                    NextLineBottom = 1
                End If
                DoubleHeight = 1

            Case 145, 146, 147, 148, 149, 150, 151
                NewForeground = cols(sbyte - 144)
                Graphics = 1

            Case 152 ' Conceal display - not sure about this
                Foreground = Background

            Case 153
                Separated = 0

            Case 154
                Separated = 1

            Case 156
                Background = cols(0)

            Case 157
                Background = Foreground

            Case 158
                HoldGraph = 1

            Case 159
                HoldGraph = 0
            
            End Select ' Special character switch
        
      ' This next line hides any non double height characters on the bottom line
      ' Fudge so that the special character is just displayed in background
      
            If (HoldGraph = 1) And (Graphics = 1) Then
                sbyte = HoldGraphChar
            Else
                sbyte = 32
            End If
             
            If Graphics Then
                If Separated Then
                    FontTypeIndex = 2
                Else
                    FontTypeIndex = 1
                End If
            Else
                FontTypeIndex = 0
            End If
            
        End If  ' test for special character
      
        If (CurrentLineBottom = 1) And ((sbyte And 127) > 31) And ((DoubleHeight = 0)) Then
            sbyte = 32
        End If
        
        ' Top bit never reaches character generator
        sbyte = sbyte And 127
        ' Our font table goes from character 32 up
    
        If sbyte < 32 Then
            sbyte = 0
        Else
            sbyte = sbyte - 32
        End If

        ' Conceal flashed text if necessary
        If ((Flash = 1) And (Mode7FlashOn = 0)) Then
            ActualForeground = Background
        Else
            ActualForeground = Foreground
        End If
        
        If (DoubleHeight = 0) Then
            For CurrentScanLine = 0 To 19
                tmp = EM7Font(FontTypeIndex, sbyte, CurrentScanLine)
                'tmp=1365;
                If (tmp = 0) Or (tmp = 255) Then
                    
                    If (tmp = 0) Then
                        col = Background
                    Else
                        col = ActualForeground
                    End If
                    
                    If col = CurrentCol(CurrentScanLine) Then
                        CurrentLen(CurrentScanLine) = CurrentLen(CurrentScanLine) + 12 * XStep
                    Else
                    
                        If CurrentLen(CurrentScanLine) Then
                            doHorizLine CurrentCol(CurrentScanLine), 20 * starty + CurrentScanLine, CurrentStartX(CurrentScanLine), CurrentLen(CurrentScanLine)
                        End If
                        CurrentCol(CurrentScanLine) = col
                        CurrentStartX(CurrentScanLine) = CurrentX
                        CurrentLen(CurrentScanLine) = 12 * XStep

                    End If ' same colour
                
                Else
                
                    CurrentPixel = &H800
                    
                    Do While CurrentPixel
                        
                        ' Background or foreground ?
                        If (tmp And CurrentPixel) <> 0 Then
                            col = ActualForeground
                        Else
                            col = Background
                        End If

                        ' Do we need to draw ?
                        If col = CurrentCol(CurrentScanLine) Then
                            CurrentLen(CurrentScanLine) = CurrentLen(CurrentScanLine) + XStep
                        Else
                            If CurrentLen(CurrentScanLine) Then
                                doHorizLine CurrentCol(CurrentScanLine), 20 * starty + CurrentScanLine, CurrentStartX(CurrentScanLine), CurrentLen(CurrentScanLine)
                            End If
                        
                            CurrentCol(CurrentScanLine) = col
                            CurrentStartX(CurrentScanLine) = CurrentX
                            CurrentLen(CurrentScanLine) = XStep
                        
                        End If ' Fore/back ground
                
                        CurrentX = CurrentX + XStep
                        CurrentPixel = CurrentPixel \ 2
                    
                    Loop ' Pixel within byte
                    
                    CurrentX = CurrentX - 12 * XStep
                    
                End If ' tmp!=0
                
            Next CurrentScanLine ' Scanline for
            
            CurrentX = CurrentX + 12 * XStep
            
            Mode7DoubleHeightFlags(CurrentChar) = 1 ' Not double height - so if the next line is double height it will be top half
        
        Else
        
            Dim ActualScanLine As Integer
            ' Double height!
            
            CurrentPixel = &H800
            
            Do While CurrentPixel
            
                For CurrentScanLine = 0 To 19
                    
                    If (CurrentLineBottom = 0) Then
                        ActualScanLine = CurrentScanLine \ 2
                    Else
                        ActualScanLine = 10 + (CurrentScanLine \ 2)
                    End If
                    
                    ' Background or foreground ?
                    If (EM7Font(FontTypeIndex, sbyte, ActualScanLine) And CurrentPixel) <> 0 Then
                        col = ActualForeground
                    Else
                        col = Background
                    End If

                    ' Do we need to draw ?
                    If col = CurrentCol(CurrentScanLine) Then
                        CurrentLen(CurrentScanLine) = CurrentLen(CurrentScanLine) + XStep
                    Else
                        
                        If CurrentLen(CurrentScanLine) Then
                            doHorizLine CurrentCol(CurrentScanLine), 20 * starty + CurrentScanLine, CurrentStartX(CurrentScanLine), CurrentLen(CurrentScanLine)
                        End If
                        
                        CurrentCol(CurrentScanLine) = col
                        CurrentStartX(CurrentScanLine) = CurrentX
                        CurrentLen(CurrentScanLine) = XStep
                        
                    End If ' Fore/back ground
                    
                Next CurrentScanLine ' Scanline for
                
                CurrentX = CurrentX + XStep
                
                CurrentPixel = CurrentPixel \ 2
                
            Loop ' Pixel within byte
            
            Mode7DoubleHeightFlags(CurrentChar) = Mode7DoubleHeightFlags(CurrentChar) Xor 1 ' Not double height - so if the next line is double height it will be top half
            
        End If
        
    Next CurrentChar

    ' Finish off right bits of scan line
    For CurrentScanLine = 0 To 19
        
        If CurrentLen(CurrentScanLine) Then
            doHorizLine CurrentCol(CurrentScanLine), 20 * starty + CurrentScanLine, CurrentStartX(CurrentScanLine), CurrentLen(CurrentScanLine)
        End If
    
    Next CurrentScanLine
    
    CurrentLineBottom = NextLineBottom
    
    NextLineBottom = 0

    Next starty
    
End Sub

Private Sub doHorizLine(col As Long, scan As Integer, start As Integer, xlen As Integer)

'   Debug.Print col, scan, start, xlen

    Picture1.Line (start, scan)-(start + xlen, scan), col

'    Sleep 10

 '   DoEvents


End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, y As Single)

Dim mx As Single
Dim my As Single
Dim cx As Integer
Dim cy As Integer
Dim c As Integer
Dim sx As Integer

    mx = X / Picture1.ScaleWidth * 40#
    my = y / Picture1.ScaleHeight * 25#

    cx = CInt(mx + 0.5) - 1
    cy = CInt(my + 0.5) - 1
    
    If cy > 0 Then
    
        If cy = 24 Then
        
            Do
                c = framebuff(0, cy, cx)
                cx = cx - 1
                
            Loop Until c = 129 Or c = 130 Or c = 131 Or c = 134 Or cx = -1
        
            If c = 129 Then
                DoLink 1
            ElseIf c = 130 Then
                DoLink 2
            ElseIf c = 131 Then
                DoLink 3
            ElseIf c = 134 Then
                DoLink 4
            End If
            
            Exit Sub
        
        End If
        
        If framebuff(0, cy, cx) >= (Asc("0") Or 128) And framebuff(0, cy, cx) <= (Asc("9") Or 128) Then
        
            c = 0
        
            Do While framebuff(0, cy, cx) >= (Asc("0") Or 128) And framebuff(0, cy, cx) <= (Asc("9") Or 128)
                cx = cx - 1
                If cx = -1 Then
                    Exit Do
                End If
            Loop
        
            cx = cx + 1
            sx = cx
        
            Do While framebuff(0, cy, cx) >= (Asc("0") Or 128) And framebuff(0, cy, cx) <= (Asc("9") Or 128)
                c = c + 1
                cx = cx + 1
                If cx = 40 Then
                    Exit Do
                End If
            Loop
        
            If c = 3 Then
            
                pn(0) = (framebuff(0, cy, sx) And 127) - 48
                pn(0) = pn(0) * 10 + (framebuff(0, cy, sx + 1) And 127) - 48
                pn(0) = pn(0) * 10 + (framebuff(0, cy, sx + 2) And 127) - 48
            
                np(1) = 48 + (pn(0) \ 100)
                np(2) = 48 + ((pn(0) \ 10) Mod 10)
                np(3) = 48 + (pn(0) Mod 10)
        
                fullflag(0) = False
                searching = True
        
                pn(1) = 0
                pn(2) = 0
                pn(3) = 0
                pn(4) = 0
        
                ClearLinkBuff
            
            End If
            
        End If
        
    End If
    
'    MsgBox CInt(mx + 0.5) - 1 & ", " & CInt(my + 0.5) - 1
    
End Sub


Private Sub Timer1_Timer()

    Mode7FlashOn = Mode7FlashOn Xor 1 ' True if a flashing character in mode 7 is on
    CurrentLineBottom = 0
    NextLineBottom = 0 ' 1 if the next line of double height should be bottoms only
    
    If fullflag(0) = True Then
        ShowMode7 24
    End If

End Sub

Sub ParseFrame(frame As Long)
    
Dim i As Integer
Dim X As Integer
Dim y As Integer
Dim mag As Integer
Dim row As Integer
Dim page As Integer
Dim pageu As Integer
Dim paget As Integer
Dim z As Integer
Dim t As Integer
Dim db As Boolean
Dim code As Integer
Dim li As Integer
Dim m As Integer
Dim offset As Long
Dim p As Integer

    offset = frame * 860
    
    For i = 3 To 15
    
        X = FrameB(offset + i * 43 + 0)
        y = FrameB(offset + i * 43 + 1)
    
        mag = (X And 2) \ 2 + ((X And 8) \ 8) * 2 + ((X And 32) \ 32) * 4
        
        If mag = 0 Then mag = 8
        
        row = (X And 128) \ 128 + ((y And 2) \ 2) * 2 + ((y And 8) \ 8) * 4 + ((y And 32) \ 32) * 8 + ((y And 128) \ 128) * 16
        
'        Debug.Print "Offset : " & Hex$(i * 43 + frame * 860) & ", Row " & i & " : " & Hex$(x) & ", " & Hex$(y) & ", " & mag & ", " & row
    
        If row = 0 Then
    
            For p = 0 To 4
            
                If mag = pn(p) \ 100 And grabflag(p) = True Then
                
                    For z = 24 To 1 Step -1
                        db = False
                        For y = 0 To 39
                            If framebuff(p, z - 1, y) = (13 Or 128) Then
                                db = True
                                y = 40
                            End If
                        Next y
                        If db = True Then
                            For y = 0 To 39
                                framebuff(p, z, y) = framebuff(p, z - 1, y)
                            Next y
                        End If
                    Next z
                
                    grabflag(p) = False
                    fullflag(p) = True
                
                    If p = 0 Then searching = False
                    
                End If
            
            Next p
            
            X = FrameB(offset + i * 43 + 2)
            y = FrameB(offset + i * 43 + 3)
            
            pageu = (X And 2) \ 2 + ((X And 8) \ 8) * 2 + ((X And 32) \ 32) * 4 + ((X And 128) \ 128) * 8
            paget = (y And 2) \ 2 + ((y And 8) \ 8) * 2 + ((y And 32) \ 32) * 4 + ((y And 128) \ 128) * 8
        
            page = mag * 100 + paget * 10 + pageu
            
            For p = 0 To 4
                
                If pn(p) = page Then
                    
                    If p = 0 Then
                        ClearFrameBuff
                    End If
                
                    grabflag(p) = True
                    fullflag(p) = False
                    
                End If
            
            Next p
            
'               Debug.Print "Page = " & page
            
            For z = 0 To 7
                framebuff(0, 0, z) = 32
            Next z
            
            If searching = True Then
                framebuff(0, 0, 1) = 1
            End If
            
            framebuff(0, 0, 2) = Asc("P")
            framebuff(0, 0, 3) = np(1)
            framebuff(0, 0, 4) = np(2)
            framebuff(0, 0, 5) = np(3)
            framebuff(0, 0, 6) = 7
            
            If mag = pn(0) \ 100 Then
                
                For z = 8 To 39
                    framebuff(0, 0, z) = (FrameB(offset + i * 43 + 2 + z) And 127) Or 128
                Next z
                    
                ShowMode7 0
                
            End If
            
        End If
           
        For p = 0 To 4
        
            If grabflag(p) = True Then
            
                If mag = pn(p) \ 100 And row <> 0 Then
                
                    If row < 25 Then
                        For z = 0 To 39
                            framebuff(p, row, z) = (FrameB(offset + i * 43 + 2 + z) And 127) Or 128
                        Next z
                    End If
                
                    If row = 27 Then
                
                        X = FrameB(offset + i * 43 + 2 + 0)
                    
                        code = deham(X)
            
                        If code = 0 Then
                
                            For li = 0 To 3
                
                                X = FrameB(offset + i * 43 + 3 + li * 6 + 0)
                                y = FrameB(offset + i * 43 + 3 + li * 6 + 1)
                
                                pl(p, li) = deham(X) + deham(y) * 10
                
                                X = FrameB(offset + i * 43 + 3 + li * 6 + 3)
                                y = FrameB(offset + i * 43 + 3 + li * 6 + 5)
                        
                                m = (deham(y) \ 4) * 2 + (deham(X) \ 8)
                            
                                pl(p, li) = pl(p, li) + 100 * (m Xor mag)
                            
                                If p = 0 Then pn(li + 1) = pl(p, li)
                                
                            Next li
                
                        End If
            
                    End If
                
                End If
            
            End If
            
        Next p
        
again:

    Next i
    
End Sub

Private Sub Timer2_Timer()

    ParseFrame curFrame
    
    curFrame = curFrame + 1
    
    If curFrame >= numFrames Then
        curFrame = 0
    End If

End Sub

Private Sub LoadChannel(chan As Integer)

Dim filen As String
Dim flen As Long
Dim X As Integer
Dim y As Integer
Dim f As Integer
Dim p As Integer

    filen = App.Path & "\txt" & Mid(Str(chan), 2) & ".dat"
    
    flen = FileLen(filen)
    
    numFrames = flen / 860#
    
    f = FreeFile
    
    Open filen For Binary As #f
    
    
' Copy in file

    ReDim FrameB(flen)
    
    Get #f, 1, FrameB
    
    Close #f
    
    For p = 0 To 4
        grabflag(p) = False
        fullflag(p) = False
        pn(p) = 0
        pl(p, 0) = 0
        pl(p, 1) = 0
        pl(p, 2) = 0
        pl(p, 3) = 0
    Next p
    
    pn(0) = 100
    searching = True
    
    curFrame = 0
    
    np(1) = 49
    np(2) = 48
    np(3) = 48
    npc = 0
    
    ClearFrameBuff
    
    Timer2.Enabled = True

End Sub

Private Sub Parse()
    
Dim txt As Integer
Dim m7File As Integer
Dim ScreenB(860) As Byte
Dim i As Integer
Dim X As Integer
Dim y As Integer
Dim mag As Integer
Dim row As Integer
Dim page As Integer
Dim pageu As Integer
Dim paget As Integer
Dim z As Integer
Dim l As String
Dim frame As Long
Dim li As Integer
Dim b As Integer
Dim code As Integer
Dim pl As Integer
Dim m As Integer

    txt = FreeFile
    
    Open App.Path & "\txt" & Mid(Str(curChan), 2) & ".txt" For Output As #txt
    
    m7File = FreeFile
    
    Open App.Path & "\txt" & Mid(Str(curChan), 2) & ".dat" For Binary As #m7File
    
' Copy in file

    For frame = 0 To numFrames
    
        Get #m7File, frame * 860 + 1, ScreenB
    
        For i = 3 To 15
    
            X = ScreenB(i * 43 + 0)
            y = ScreenB(i * 43 + 1)
    
            mag = (X And 2) \ 2 + ((X And 8) \ 8) * 2 + ((X And 32) \ 32) * 4
        
            If mag = 8 Then mag = 8
            
            row = (X And 128) \ 128 + ((y And 2) \ 2) * 2 + ((y And 8) \ 8) * 4 + ((y And 32) \ 32) * 8 + ((y And 128) \ 128) * 16
        
'            Debug.Print "Offset : " & Hex$(i * 43 + frame * 860) & ", Row " & i & " : " & Hex$(x) & ", " & Hex$(y) & ", " & mag & ", " & row & " ";
            Print #txt, "Offset : " & Hex$(i * 43 + frame * 860) & ", Row " & i & " : " & Hex$(X) & ", " & Hex$(y) & ", " & mag & ", " & row & " ";
    
            If row = 0 And X <> 0 Then
        
                X = ScreenB(i * 43 + 2)
                y = ScreenB(i * 43 + 3)
            
                pageu = (X And 2) \ 2 + ((X And 8) \ 8) * 2 + ((X And 32) \ 32) * 4 + ((X And 128) \ 128) * 8
                paget = (y And 2) \ 2 + ((y And 8) \ 8) * 2 + ((y And 32) \ 32) * 4 + ((y And 128) \ 128) * 8
            
                page = mag * 100 + paget * 10 + pageu
            
'                Debug.Print "Page = " & page & " ";
                Print #txt, "Page = " & page & " ";
            
                l = ""
                
                For z = 0 To 7
                    l = l & Chr$(32)
                Next z
                For z = 8 To 39
                    l = l & Chr$(ScreenB(i * 43 + 2 + z) And 127)
                Next z
                    
'                Debug.Print l
                Print #txt, l
       
            End If
           
            If row <> 0 And row <> 27 Then
                
                l = ""
                
                For z = 0 To 39
                    l = l & Chr$(ScreenB(i * 43 + 2 + z) And 127)
                Next z
            
'                Debug.Print l
                Print #txt, l
            
            End If
        
            If row = 27 Then
            
                X = ScreenB(i * 43 + 2 + 0)
                
                code = deham(X)
            
                l = "Code = " & code & ", "
                
                For li = 1 To 4
                
                    l = l & "Link " & li & " = "
                    
                    For b = 0 To 5
                        X = ScreenB(i * 43 + 3 + (li - 1) * 6 + b)
                
                        code = deham(X)
                        
                        l = l & code & ", "
                        
                    Next b
                
                    X = ScreenB(i * 43 + 3 + (li - 1) * 6 + 0)
                    y = ScreenB(i * 43 + 3 + (li - 1) * 6 + 1)
                
                    pl = deham(X) + deham(y) * 10
                
                    X = ScreenB(i * 43 + 3 + (li - 1) * 6 + 3)
                    y = ScreenB(i * 43 + 3 + (li - 1) * 6 + 5)
                        
                    m = (deham(y) \ 4) * 2 + (deham(X) \ 8)
                            
                    pl = pl + 100 * (m Xor mag)
                
                    l = l & code & ", Page = " & pl & ", "
                
                Next li
                
                Print #txt, l
            
            End If

again:

        Next i
    
    Next frame
    
    Close #m7File
    Close #txt
    
End Sub


Function deham(b As Integer) As Integer

    deham = (b And 2) \ 2 + ((b And 8) \ 8) * 2 + ((b And 32) \ 32) * 4 + ((b And 128) \ 128) * 8
    
End Function

Private Sub ClearFrameBuff()
            
Dim X As Integer
Dim y As Integer
Dim z As Integer

    For z = 0 To 4
        grabflag(z) = False
        fullflag(z) = False
        
        If z > 0 Then
            pn(z) = 0
            pl(z, 0) = 0
            pl(z, 1) = 0
            pl(z, 2) = 0
            pl(z, 3) = 0
        End If
        
        For X = 0 To 24
            For y = 0 To 39
                framebuff(z, X, y) = 32
            Next y
        Next X
    Next z

End Sub

Private Sub ClearLinkBuff()
            
Dim X As Integer
Dim y As Integer
Dim z As Integer

    For z = 1 To 4
        
        grabflag(z) = False
        fullflag(z) = False
        
        pl(z, 0) = 0
        pl(z, 1) = 0
        pl(z, 2) = 0
        pl(z, 3) = 0
        
        For X = 0 To 24
            For y = 0 To 39
                framebuff(z, X, y) = 32
            Next y
        Next X
    
    Next z

End Sub

